from __future__ import annotations

from collections.abc import Mapping
from typing import Any, Self, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..models.size_unit import SizeUnit

T = TypeVar("T", bound="Size")


@_attrs_define
class Size:
    """Attributes:
    field_value (int):
    field_unit (SizeUnit):
    """

    field_value: int
    field_unit: SizeUnit
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        field_value = self.field_value

        field_unit = self.field_unit.value

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "_value": field_value,
                "_unit": field_unit,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls, src_dict: Mapping[str, Any]) -> Self:
        d = dict(src_dict)
        field_value = d.pop("_value")

        field_unit = SizeUnit(d.pop("_unit"))

        size = cls(
            field_value=field_value,
            field_unit=field_unit,
        )

        size.additional_properties = d
        return size

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
